#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

.plugin lite86;                     ;the ultimate compression routine

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068

Str_A   equ   $ca00
Str_B   equ   $ca00+10
Str_C   equ   $ca00+20
Str_D   equ   $ca00+30
Str_E   equ   $ca00+40
Str_F   equ   $ca00+50

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String1                     ;print string

String1:    .db "Weak Acid/Base Solver",0

Start:
    call Set_Variables              ;goes to Set_Variables
    call _clrScrn
    call _flushallmenus             ;clears all key codes
    call _runindicoff
    call _homeup
    ld hl,String1
    call _puts
    ld hl,(256*5)+1                 ;loads coordinates into hl, row 2, col 3
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String2                   ;loads hl with string
    call _puts                      ;print string
    ld hl,(256*5)+2                 ;loads coordinates into hl, row 2, col 3
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String3                   ;loads hl with string
    call _puts                      ;print string
    ld hl,(256*1)+4                 ;loads coordinates into hl, row 2, col 3
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String4                   ;loads hl with string
    call _puts                      ;print string
    ld hl,String5
    ld bc,256*58+7
    ld (_penCol),bc
    call _vputs
    ld bc,256*58+31
    ld (_penCol),bc
    call _vputs
    ld bc,256*58+107
    ld (_penCol),bc
    call _vputs
    call MenuRoutine1
GetKey:
    call _getcode
    cp K_EXIT
    jp z, Exit
    cp K_ALPHA
    call z,CalcOff
    cp K_F1                         ;compares a with F1 key
    jp z,Acid                       ;if F1 jump to VAR1
    cp K_F2                         ;compares a with F2 key
    jp z,Base                       ;if F2 jump to VAR2
    cp K_F5
    jp z,Exit
    jr GetKey                       ;relative jump to GetKey

Math:
    ld hl,Str_A
    call Recall
    rst 08h
    ld hl,Str_C
    call Recall
    rst 30h
    rst 08h
    ld hl,Str_D
    call Recall
    rst 30h
    ld de,Str_F
    call Create
    ld hl,Str_B
    call Recall
    rst 08h
    ld hl,Str_A
    call Recall
    rst 28h
    call _op1toop6
    ld hl,Str_C
    call Recall
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    call _op6toop2
    call _FPSUB
    ld a,4
    call _setXXop2
    rst 28h
    call _op1toop6
    ld hl,Str_F
    call Recall
    call _FPSQUARE
    call _op6toop2
    call _FPSUB
    call _SQROOT
    call _op1toop6
    ld hl,Str_F
    call Recall
    call _op6toop2
    call _FPSUB
    call _TIMESPT5
    call _invop1s    
    ld de,Str_A
    call Create
    rst 08h
    ld hl,Str_C
    call Recall
    rst 30h
    ld de,Str_E
    call Create
    ld hl,Str_A
    call Recall
    rst 08h
    ld hl,Str_B
    call Recall
    call _FPSUB
    ld de,Str_B
    call Create
    ld hl,Str_A
    call Recall
    rst 08h
    ld hl,Str_D
    call Recall
    rst 30h
    ld de,Str_D
    call Create
    ld hl,Str_E
    call Recall
    call _LOGXP
    call _invop1s
    ld de,Str_C
    call Create
    rst 08h
    ld a,14
    call _setXXop1
    call _FPSUB
    ld de,Str_A
    call Create
    ret

Acid:
    call _clrScrn
    call _homeup
    ld hl,String8
    call Input
    ld de,Str_A
    call Create
    call _newline
    ld hl,String18
    call _puts
    ld hl,String20
    call _puts
    ld hl,String23
    call Input
    ld de,Str_B
    call Create
    call _newline
    ld hl,String10
    call _puts
    ld hl,String23
    call Input
    ld de,Str_C
    call Create
    call _newline
    call _newline
    ld hl,(256*0)+6                 ;loads coordinates into hl, row 2, col 3
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String18                  ;loads hl with string
    call _puts                      ;print string
    ld hl,String22
    call _puts
    ld hl,String23
    call Input
    ld de,Str_D
    call Create
    call Math
    call _clrScrn
    call _homeup
    ld hl,String12
    call _puts
    ld hl,Str_E
    call Recall
    call DispAnswer2
    call _newline
    ld hl,String13
    call _puts
    ld hl,String24
    call _puts
    ld hl,Str_E
    call Recall
    call DispAnswer2
    call _newline
    call _newline
    ld hl,String14
    call _puts
    ld hl,Str_C
    call Recall
    call DispAnswer1
    call _newline
    ld hl,String15
    call _puts
    ld hl,Str_A
    call Recall
    call DispAnswer1
    call _newline
    call _newline
    ld hl,String16
    call _puts
    ld hl,Str_B
    call Recall
    call DispAnswer2
    call _newline
    ld hl,String17
    call _puts
    ld hl,Str_D
    call Recall
    call DispAnswer2
    call _getkey
    jp Start
    
Base:
    call _clrScrn
    call _homeup
    ld hl,String9
    call Input
    ld de,Str_A
    call Create
    call _newline
    ld hl,String18
    call _puts
    ld hl,String19
    call _puts
    ld hl,String23
    call Input
    ld de,Str_B
    call Create
    call _newline
    ld hl,String11
    call _puts
    ld hl,String23
    call Input
    ld de,Str_C
    call Create
    call _newline
    call _newline
    ld hl,(256*0)+6                 ;loads coordinates into hl, row 2, col 3
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String18                  ;loads hl with string
    call _puts                      ;print string
    ld hl,String21
    call _puts
    ld hl,String23
    call Input
    ld de,Str_D
    call Create
    call Math
    call _clrScrn
    call _homeup
    ld hl,String12
    call _puts
    ld hl,String24
    call _puts
    ld hl,Str_E
    call Recall
    call DispAnswer2
    call _newline
    ld hl,String13
    call _puts
    ld hl,Str_E
    call Recall
    call DispAnswer2
    call _newline
    call _newline
    ld hl,String14
    call _puts
    ld hl,Str_A
    call Recall
    call DispAnswer1
    call _newline
    ld hl,String15
    call _puts
    ld hl,Str_C
    call Recall
    call DispAnswer1
    call _newline
    call _newline
    ld hl,String16
    call _puts
    ld hl,Str_D
    call Recall
    call DispAnswer2
    call _newline
    ld hl,String17
    call _puts
    ld hl,Str_B
    call Recall
    call DispAnswer2
    call _getkey
    jp Start

Set_Variables:
    xor a
    call _setXXop1
    ld de,Str_A
    call Create
    ld de,Str_B
    call Create
    ld de,Str_C
    call Create
    ld de,Str_D
    call Create
    ld de,Str_E
    call Create
    ld de,Str_F
    call Create
    ret

Create:                     ;save num from OP1
    ld hl,_OP1              ;move 10 bytes from op1
    call _mov10b
    ret

Recall:                     ;restore num to OP1
    ld de,_OP1              ;number to op1
    call _mov10b
    ret

DispAnswer1:
    ld d,2
    call _ROUND
    jr SubDispAnswer
DispAnswer2
    ld d,3
    call _ROUND
SubDispAnswer:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _puts                      ;prints answer
    call _runindicoff               ;turn off run indicator
    ret

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return to call

CalcOff:
    ld a,1
    out (3),a
    halt
    ld a,11
    out (3),a        
    res onInterrupt,(iy+onflags)
    ret

Exit:
    call Set_Variables              ;goes to Set_Variables
    call _clrScrn                   ;clears the screen
    call _homeup                    ;moves cursor to upper left
    ret

#include "Menu86.asm";  <-- routine that draws the 86 style menus

String2:    .db "TI-86 v2.4",0
String3:    .db "2004-05-14",0
String4:    .db "by Daniel J. Bishop  dan2k@hotmail.com",0
String5:    .db "ACID",0
String6:    .db "BASE",0
String7:    .db "EXIT",0
String8:    .db "Ka=?",0
String9:    .db "Kb=?",0
String10:   .db "Initial [H+]",0
String11:   .db "Initial [OH",26,"]",0
String12:   .db "[H+]=",0
String13:   .db "[OH",26,"]=",0
String14:   .db "pH=",0
String15:   .db "pOH=",0
String16:   .db "[Acid]=",0
String17:   .db "[Base]=",0
String18:   .db "Initial molarity of  ",0
String19:   .db "weak base",0
String20:   .db "weak acid",0
String21:   .db "conjugate acid",0
String22:   .db "conjugate base",0
String23:   .db "=?",0
String24:   .db "1",27,26,"14/",0

.end
END4